﻿using BackgroundLiveTileSample.CL;
using NotificationsExtensions.TileContent;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.ApplicationModel.Background;
using Windows.UI.Notifications;

namespace BackgroundLiveTileSample.BackgroundTasks
{
    public sealed class TileUpdateTask : IBackgroundTask
    {
        const string feedUri = "http://web2.ruliweb.daum.net/daum/rss.htm?bbs=1&id=547&bbsId=G007&c1=6&c2=5";

        BackgroundTaskDeferral _deferral = null;

        RssReaderViewModel RssReader;

        //백그라운드테스크 이벤트 처리부분
        public async void Run(IBackgroundTaskInstance taskInstance)
        {
            // Get the deferral object from the task instance, and take a reference to the taskInstance;
            _deferral = taskInstance.GetDeferral();

            RssReader = RssReaderViewModel.Instance;

            var result = await RssReader.GetFeed(new Uri(feedUri));
            if (result == true)
            {
                UpdateTile();
            }
            //백그라운드 작업 완료
            _deferral.Complete();
        }

        //타일 업데이트
        public void UpdateTile()
        {
            //타일 로테이션 가능하도록 변경
            TileUpdateManager.CreateTileUpdaterForApplication().EnableNotificationQueue(true);

            foreach (var item in RssReader.CurrentFeed.Items.Take(5))
            {
                //큰타일
                ITileWideText09 tileContent = TileContentFactory.CreateTileWideText09();
                tileContent.TextHeading.Text = item.Title.Text;
                tileContent.TextBodyWrap.Text = item.Summary.Text;

                //작은타일
                ITileSquareText02 squareContent = TileContentFactory.CreateTileSquareText02();
                squareContent.TextHeading.Text = item.Title.Text;
                squareContent.TextBodyWrap.Text = item.Summary.Text;
                tileContent.SquareContent = squareContent;

                //타일노티 만들고
                TileNotification tileNotification = tileContent.CreateNotification();
                //tileNotification.Tag = item.Id;

                //센드 타일
                TileUpdateManager.CreateTileUpdaterForApplication().Update(tileNotification);
            }
        }
    }
}
