﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Notifications;
using Windows.Web.Syndication;

namespace BackgroundLiveTileSample.CL
{
    public class RssReaderViewModel : BindableBase
    {
        SyndicationClient client;

        private static RssReaderViewModel instance;
        //인스턴스 객체
        public static RssReaderViewModel Instance 
        { 
            get 
            {
                if (instance == null)
                {
                    instance = new RssReaderViewModel();
                }
                return instance;
            } 
        }

        private SyndicationFeed currentFeed;
        /// <summary>
        /// 현재 피드
        /// </summary>
        public SyndicationFeed CurrentFeed
        {
            get { return currentFeed; }
            set 
            { 
                currentFeed = value;
                OnPropertyChanged();
            }
        }

        public RssReaderViewModel()
        {
            client = new SyndicationClient();
            client.BypassCacheOnRetrieve = true;
            client.SetRequestHeader("User-Agent", "Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; WOW64; Trident/6.0)");
        }

        public async Task<bool> GetFeed(Uri feedUri)
        {
            try
            {
                CurrentFeed = await client.RetrieveFeedAsync(feedUri);
                return true;
            }
            catch (Exception ex)
            {
                return false;
            }
        }
    }
}
